# joylink  device sdk  nodejs 版 用户手册  


##  1. 概述及说明  
为简化设备开发流程，实现设备的快速接入，提供了nodejs版的设备接入SDK参考。 在使用SDK之前，默认用户已经在物联平台完成设备创建等相关工作，并得到了设备标识、设备证书等所需要的信息。 



##  2. 名词解释  

为了方便用户能够快速的对使用手册进行约定，进而进行设备接入，对涉及到的相关名词进行简单说明。

**直连设备**：具备通过MQTT协议连接到物联平台的设备； 

**非直连设备**：不具备通过MQTT协议连接到物联平台的设备； 

**网关设备**：具备通过MQTT协议连接到物联平台，并且能够为非直连设备提供代理接入物联平台； 

**子设备**：这里指的时非直连设备； 

**属性**：一些可能表示状态，条件的独立参数，例如时间，名称，版本，温度，容量，开关等基础属性； 

**方法**：一个方法是一个具体的操作，有入参与出参，通过调用可以得到一个结果； 

**事件**：一些由条件触发的消息，由设备端主动发出；

**实例名 （key）**：物模型中一个属性实例，事件实例，方法实例，模型实例的唯一标识。需要在物模型中保持唯一；

**服务实例名**：可选值 {NULL, "connection_agent", "ota", “config”}，SDK目前支持的取值 {NULL}；

**connection_agent**：一个内置的代理服务，对于网关设备此服务为必选，用于代理子设备完成相应的功能；直连设备可不需要该服务;  



##  3. 引用文件  

无 


##  4. 安装编译和运行

编译 joylink_device_sdk_nodejs

外部依赖
--------------
[1] mqtt
[2] log4js

joylink sdk build step
--------------
step 1:
    % npm install
step 2:
    % npm run build

joylink sdk local develop step
--------------
step 1:
    % npm install
step 2:
    % npm run dev

## 5. 用户开发说明
### 5.1. 初始化客户端
开发者使用SDK来进行应用的开发，必须先初始化 joylink sdk ,初始化需要物管平台的hostname，端口号，设备标识和设备证书。
```
joySDK = joylink.NewSDK(joyConfig)
```
### 5.2. 创建设备
设备的创建和初始化，需要根据在物管平台进行的物模型定义。设备类型主要有三种，直连设备、网关设备和子设备。其中网关设备本质上也属于直连设备。

#### 5.2.1. 直连设备
开发者需要实现 连接成功、物模型上报回执、属性设置、属性获取、方法调用的回调接口实现，如下所示：
```
joySDK.SetDevCallBackConnect(dev.CallBackOnConnect)
joySDK.SetDevCallBackThMdPostRes(dev.CallBackOnThingModelPostRes)
joySDK.SetDevCallBackPropSet(dev.CallBackOnPropertiesSet)
joySDK.SetDevCallBackPropGet(dev.CallBackOnPropertiesGet)
joySDK.SetDevCallBackFuncCall(dev.CallBackOnFunctionsCall)
```

开发者初始化设备
```
dev.Initialise(joyConfig.DeviceId, joySDK)
```


#### 5.2.2. 网关设备
网关设备本质是一种直连设备，与直连设备相比，网关设备含有connection_agent 服务模型，需开发者按照文档自行实现。
```
...

```

**附加说明**

> [1] 对象空间(obj_name)的取值，SDK目前仅支持 {”device“}；
>
> [2] 目前默认每次只有一个函数调用 即 in_call->func_num == 1；
>
> [3] 如果是网关设备，并且需要使用物联平台下发的子设备的信息，那么当服务实例名（service_key） 为 ”connection_agent“ 时，需要根据实际的需求处理服务内置的四个方法调用，方法调用的实例名如下：
>
> > 添加子设备：”connection_agent.add-devices“；
> > 删除子设备：“connection_agent.delete-devices”；
> > 更新子设备：“connection_agent.update-devices”；
> > 查询子设备：“connection_agent.get-devices”；
>
> [4] 如果是网关设备时，需要根据消息里的设备标识来判断是调用的哪个子设备的方法。
>
> [5] 如果服务实例名（service_key） 为 ”ota“ 时，需要根据实际需求处理ota服务内置的4个方法调用：
>
> > ota指令：”ota.ota“；
> > 取消任务：“ota.cancel-task”；
> > 执行任务：“ota.exec-task”；
> > 查询状态：“ota.query-ota-state”；
>
> [5] 方法调用完成后，需要给出响应。